#ifndef __GP2X_H
#define __GP2X_H

#include <stdio.h>

int  gp2x_do_menu();
void gp2x_display_vol();
void gp2x_mute();
void gp2x_unmute();
void gp2x_poll();
void gp2x_init();
void gp2x_deinit();
void gp2x_init_sound();
void gp2x_joystick_read();
void gp2x_perform_menu();
void gp2x_perform_keyboard();
void gp2x_flush();
void gp2x_toggle_stick();
void gp2x_toggle_region();
void gp2x_std_stick();
void gp2x_swap_stick();
void gp2x_init_stick();
void gp2x_reset();
bool gp2x_choose_rom(char *rom);
bool gp2x_load_rom(char *file);
bool gp2x_load_rom();
void gp2x_set_state_name(char *file);
long gp2x_filesize(FILE *stream);
void gp2x_write_to_file(char *txt);
void gp2x_display_info();
void gp2x_display_loading();
void gp2x_display_loaded();
bool gp2x_load_bios(char *biosname);
int  gp2x_savestate();
int  gp2x_loadstate();
void gp2x_display_msg(char *msg, int waits);
void gp2x_display_msg_and_stop(char *msg);
void gp2x_menu_txt(int x, int y, int fore, const char *msg);
bool gp2x_no_command();

typedef struct
{
	char *filename;
	int   type;
	int   size;
	int   perms;
	int   links;
}gp2x_dir_ent;

typedef struct
{
	char         *path;
	gp2x_dir_ent *elements;
	int           elem_count;
	int           elem_size;
} gp2x_dir_list;

void           gp2x_dirlist_destroy(gp2x_dir_list* listing);
gp2x_dir_list *gp2x_dirlist_load(const char *path);
char          *gp2x_dirlist_get_path(gp2x_dir_list *listing, int n);
void           gp2x_fill_entry(gp2x_dir_list *listing, gp2x_dir_ent *entry, const char *filename);

#endif


